; ADVMAIN/SYSTEM1.1
; Copyright (C) 2011 saguruma
;
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.

; *** RAM reserve ***
Adv_seq_LSB         = $D0
Adv_seq_MSB         = $D1
Adv_seqData0        = $D2
Adv_seqData1        = $D3
Adv_cursorCol       = $D4
Adv_cursorRow       = $D5
Adv_clistData_LSB   = $D6
Adv_clistData_MSB   = $D7
Adv_clistSize       = $D8

Adv_cursorSprite_Y  = $0204
Adv_cursorSprite_I  = $0205
Adv_cursorSprite_A  = $0206
Adv_cursorSprite_X  = $0207

Adv_seqIndex        = $0310
Adv_clistIndex      = $0311
Adv_clistSelected   = $0312
Adv_varpos          = $0313
Adv_skip            = $0314
Adv_pallet          = $0320
Adv_vardata         = $0340

; *** constants ***
Adv_VRAMBASE1_LSB   = $03
Adv_VRAMBASE1_MSB   = $22
Adv_VRAMBASE2_LSB   = $17
Adv_VRAMBASE2_MSB   = $22
Adv_MSGBOXWIDTH     = 16
Adv_CURSORBASE_X    = 24
Adv_CURSORBASE_Y    = 134
Adv_COMMANDBASE_X   = 176
Adv_COMMANDBASE_Y   = 134

;******************************************************************************
; main #0
;******************************************************************************
Adv_main0:
  inc <currentActivity
  ldx <currentActivity
  lda activities, x
  asl a
  tax
  lda Adv_main_VECTOR, x
  sta <address1_LSB
  inx
  lda Adv_main_VECTOR, x
  sta <address1_MSB
  jmp [address1_LSB]

Adv_main_VECTOR:
  .dw Adv_init          ; #0 
  .dw Adv_fadein        ; #1 tF[hC
  .dw Adv_processEvents ; #2 Cxg
  .dw Adv_updateScreen  ; #3 ʍXV
  .dw Adv_commandList   ; #4 R}hXg
  .dw Password_create   ; #5 pX[h쐬
  .dw 0                 ; #6
  .dw 0                 ; #7
  .dw 0                 ; #8
  .dw 0                 ; #9
  .dw Adv_fadeout       ; #10 tF[hAEg
  .dw Adv_terminate     ; #11 iGfBONWbgj

Adv_terminate:
  ; Sprite #1 J[\
  lda #0
  sta Adv_cursorSprite_Y
  sta Adv_cursorSprite_X
  lda #$03
  sta Adv_cursorSprite_A
  lda #$0F
  sta Adv_cursorSprite_I

  lda #0
  ldx <currentActivity
  sta activities, x
  sta processCounters, x
  dex
  inc activities, x
  sta processCounters, x
  rts


;******************************************************************************
; main #1
;******************************************************************************
Adv_main1:

.waitScan:
  bit REG_PPU_2
  bvs .waitScan
.waitHit:
  bit REG_PPU_2
  bvc .waitHit

  lda #$80 ; enable NMI
           ; BG $0000
           ; SP $0000 8x8
  sta REG_PPU_0
  rts


;******************************************************************************
; init (activity #0)
;******************************************************************************
Adv_init:
  lda #0
  sta Snd_bgm
  sta Snd_sfx
  
  lda #1
  jsr MMC_changeCHR_Low

  lda #1
  jsr MMC_changeCHR_High

  ; load BG $2000-$23BF
  lda #low(Adv_BG)
  sta <address1_LSB
  lda #high(Adv_BG)
  sta <address1_MSB
  lda #$00
  sta <address2_LSB
  lda #$20
  sta <address2_MSB
  lda #$C0
  sta <wordparam_LSB
  lda #$03
  sta <wordparam_MSB
  jsr loadVRAM

  ; load BG Attr $23C0-$23FF
  lda #low(Adv_BGA)
  sta <address1_LSB
  lda #high(Adv_BGA)
  sta <address1_MSB
  lda #$C0
  sta <address2_LSB
  lda #$23
  sta <address2_MSB
  lda #$40
  sta <wordparam_LSB
  lda #$00
  sta <wordparam_MSB
  jsr loadVRAM

  ; Sprite #0
  lda #122
  sta SPRITE_Y
  lda #248
  sta SPRITE_X
  lda #$BE
  sta SPRITE_I
  lda #$43
  sta SPRITE_A

  ; Sprite #1 J[\
  lda #0
  sta Adv_cursorSprite_Y
  sta Adv_cursorSprite_X
  lda #$03
  sta Adv_cursorSprite_A
  lda #$BE
  sta Adv_cursorSprite_I

  lda #$00
  sta <Adv_cursorCol
  sta <Adv_cursorRow

  lda Adv_skip
  cmp #$80
  bne .next
  lda #$FF
  sta Image1_index ; [h̏ꍇ͕K摜XVs悤ɂB
  sta Image2_index
.next:
  ldx <currentActivity
  inc activities, x
  rts


;******************************************************************************
; fade in (activity #1)
;******************************************************************************
Adv_fadein:
  lda Adv_skip
  cmp #$80
  beq .skip ; [hȂ̂ŃtF[hCXLbv
  lda #low(Adv_pallet)
  sta <address1_LSB
  lda #high(Adv_pallet)
  sta <address1_MSB
  jmp Util_fadein ; ėptF[hC
.skip:
  ldx <currentActivity
  inc activities, x
  rts


;******************************************************************************
; fade out (activity #10)
;******************************************************************************
Adv_fadeout:
  lda #low(Adv_pallet)
  sta <address1_LSB
  lda #high(Adv_pallet)
  sta <address1_MSB
  jmp Util_fadeout ; ėptF[hAEg


;******************************************************************************
; process events (activity #2)
;******************************************************************************
Adv_processEvents:
  lda Adv_skip
  and #$80 ; [htO̓NAȂi摜tF[hCŃNAj
  sta Adv_skip
  ldx <currentActivity
  inc activities, x

  lda #0
  jsr MMC_changePRG
  jsr EventsDecision

  lda #0
  sta Adv_clistSelected
  lda Adv_seqIndex
  asl a
  tay
  lda Adv_seqvector, y
  sta <Adv_seq_LSB
  iny
  lda Adv_seqvector, y
  sta <Adv_seq_MSB
  rts


;******************************************************************************
; update screen (activity #3)
;******************************************************************************
Adv_updateScreen:
  lda Adv_skip
  and #$01
  bne .skip
  inc <currentActivity
  ldx <currentActivity
  lda activities, x
  asl a
  tax
  lda Adv_updateScreen_VECTOR, x
  sta <address1_LSB
  inx
  lda Adv_updateScreen_VECTOR, x
  sta <address1_MSB
  jmp [address1_LSB]
.skip:
  ldx <currentActivity
  inc activities, x
  rts

Adv_updateScreen_VECTOR:
  .dw Adv_readSeq       ; #0 V[PXǍ
  .dw Adv_readVar       ; #1 σf[^Ǎ
  .dw Adv_clearText     ; #2 y[WieLXgNAj
  .dw Adv_drawChar      ; #3 Po
  .dw Image1_main       ; #4 摜1
  .dw Image2_main       ; #5 摜2
  .dw Adv_waitPadIn     ; #6 V[PX̓͑҂


;******************************************************************************
; read sequence (activity #3-0)
;******************************************************************************
Adv_readSeq:
  ; PRG #0
  ldy Adv_seqIndex
  lda Adv_seqbank, y
  jsr MMC_changePRG

Adv_readSeq_1:
  ldy #0
  lda [Adv_seq_LSB], y
  sta <Adv_seqData0
  inc <Adv_seq_LSB
  bne .checkCommand
  inc <Adv_seq_MSB
.checkCommand:
  lda <Adv_seqData0
  cmp #$79 ; _
  beq Adv_cmdX2
  cmp #$7A ; _
  beq Adv_cmdX2
  and #$F0
  cmp #$F0
  bne Adv_cmdX1
  lda <Adv_seqData0
  and #$0F
  asl a
  tay
  lda Adv_readSeq_cmdvector, y
  sta <address1_LSB
  iny
  lda Adv_readSeq_cmdvector, y
  sta <address1_MSB
  ldy #0
  jmp [address1_LSB]

Adv_readSeq_cmdvector:
  .dw Adv_cmdF0, Adv_cmdF1, Adv_cmdF2, Adv_cmdF3
  .dw Adv_cmdX1, Adv_cmdX1, Adv_cmdX1, Adv_cmdX1
  .dw Adv_cmdF8, Adv_cmdF9, Adv_cmdX1, Adv_cmdX1
  .dw Adv_cmdFC, Adv_cmdFD, Adv_cmdFE, Adv_cmdFF

Adv_cmdX1: ; Pói_Ȃj
  lda <Adv_seqData0
  sta <Adv_seqData1
  lda #$00
  sta <Adv_seqData0
.next:
  ldx <currentActivity
  lda #3
  sta activities, x
  rts

Adv_cmdX2: ; Pói_j
  lda [Adv_seq_LSB], y
  sta <Adv_seqData1
  inc <Adv_seq_LSB
  bne .next
  inc <Adv_seq_MSB
.next:
  ldx <currentActivity
  lda #3
  sta activities, x
  rts

Adv_cmdF0: ; s
  lda #0
  sta <Adv_cursorCol
  inc <Adv_cursorRow
  bne Adv_readSeq_1

Adv_cmdF1: ; 摜1
  lda [Adv_seq_LSB], y
  cmp Image1_index
  beq .skip ; ݕ\ƓȂXLbv
  sta Image1_index
  inc <Adv_seq_LSB
  bne .next
  inc <Adv_seq_MSB
.next:
  ldx <currentActivity
  lda #4
  sta activities, x
  rts
.skip:
  inc <Adv_seq_LSB
  bne .continue
  inc <Adv_seq_MSB
.continue:
  rts

Adv_cmdF2: ; 摜2
  lda [Adv_seq_LSB], y
  cmp Image2_index
  beq .skip ; ݕ\ƓȂXLbv
  sta Image2_index
  inc <Adv_seq_LSB
  bne .next
  inc <Adv_seq_MSB
.next:
  ldx <currentActivity
  lda #5
  sta activities, x
  rts
.skip:
  inc <Adv_seq_LSB
  bne .continue
  inc <Adv_seq_MSB
.continue:
  rts

Adv_cmdF3: ; σf[^Ǎ
  lda [Adv_seq_LSB], y
  asl a
  asl a
  asl a
  asl a
  sta Adv_varpos
  inc <Adv_seq_LSB
  bne .next
  inc <Adv_seq_MSB
.next:
  ldx <currentActivity
  lda #1
  sta activities, x
  rts

Adv_cmdF8: ; BGM
  lda [Adv_seq_LSB], y
  sta Snd_bgm
  inc <Adv_seq_LSB
  bne .continue
  inc <Adv_seq_MSB
.continue:
  rts

Adv_cmdF9: ; SFX
  lda [Adv_seq_LSB], y
  sta Snd_sfx
  inc <Adv_seq_LSB
  bne .continue
  inc <Adv_seq_MSB
.continue:
  rts

Adv_cmdFC: ; GhNWbg
  ldx <currentActivity
  lda #0
  sta activities, x
  sta processCounters, x
  dex
  sta processCounters, x
  lda #10
  sta activities, x
  rts

Adv_cmdFD: ; ͑҂
  ldx <currentActivity
  lda #6
  sta activities, x
  rts

Adv_cmdFE: ; y[W
  lda #$0F
  sta Adv_cursorSprite_I
  ldx <currentActivity
  lda #2
  sta activities, x
  rts

Adv_cmdFF: ; I[
  lda #0
  sta Adv_cursorSprite_X
  sta Adv_cursorSprite_Y

  ldx <currentActivity
  lda #0
  sta activities, x
  sta processCounters, x
  dex
  inc activities, x
  sta processCounters, x
  rts


;******************************************************************************
; readVar (activity #3-1)
;******************************************************************************
Adv_readVar:
  ldy Adv_varpos
  lda Adv_vardata, y
  sta <Adv_seqData0
  iny
  lda Adv_vardata, y
  sta <Adv_seqData1
  iny
  sty Adv_varpos

.check:
  ldy Adv_varpos
  tya
  and #$0F
  beq .next0
  lda Adv_vardata, y
  cmp #$FF
  beq .next0
  bne .next3
.next0:
  lda #0
  sta Adv_varpos
.next3:
  ldx <currentActivity
  lda #3
  sta activities, x
  rts


;******************************************************************************
; clear (activity #3-2)
;******************************************************************************
Adv_clearText:
  ldx <currentActivity
  lda processCounters, x
  cmp #Adv_MSGBOXWIDTH
  bcc .clear
  
.term:
  lda #0
  sta activities, x
  sta processCounters, x
  sta <Adv_cursorCol
  sta <Adv_cursorRow
  rts

.clear:
  lda #$04
  sta REG_PPU_0

  lda REG_PPU_2
  lda #Adv_VRAMBASE1_MSB
  sta REG_PPU_6
  lda processCounters, x
  clc
  adc #Adv_VRAMBASE1_LSB
  sta REG_PPU_6

  lda #$00
  sta REG_PPU_7
  sta REG_PPU_7
  sta REG_PPU_7
  sta REG_PPU_7
  sta REG_PPU_7
  sta REG_PPU_7
  sta REG_PPU_7
  sta REG_PPU_7
  sta REG_PPU_7
  sta REG_PPU_7

  inc processCounters, x
  rts


;******************************************************************************
; drawChar (activity #3-3)
;******************************************************************************
Adv_drawChar:
  lda #$04
  sta REG_PPU_0

  lda #Adv_VRAMBASE1_LSB
  sta <address1_LSB
  lda #Adv_VRAMBASE1_MSB
  sta <address1_MSB
  lda <Adv_cursorCol
  clc
  adc <address1_LSB
  sta <address1_LSB
  lda <Adv_cursorRow
  asl a
  asl a
  asl a
  asl a
  asl a
  asl a
  clc
  adc <address1_LSB
  sta <address1_LSB

  lda REG_PPU_2
  lda <address1_MSB
  sta REG_PPU_6
  lda <address1_LSB
  sta REG_PPU_6

  lda <Adv_seqData0
  sta REG_PPU_7
  lda <Adv_seqData1
  sta REG_PPU_7

  inc <Adv_cursorCol
  lda <Adv_cursorCol
  cmp #Adv_MSGBOXWIDTH
  bcc .moveCursor
  lda #0
  sta <Adv_cursorCol
  inc <Adv_cursorRow

.moveCursor:
  lda <Adv_cursorCol
  asl a
  asl a
  asl a
  clc
  adc #Adv_CURSORBASE_X
  sta Adv_cursorSprite_X
  lda <Adv_cursorRow
  asl a
  asl a
  asl a
  asl a
  clc
  adc #Adv_CURSORBASE_Y
  sta Adv_cursorSprite_Y
  lda #$BE
  sta Adv_cursorSprite_I

  lda Adv_varpos
  beq .next0
.next1:
  ldx <currentActivity
  lda #1
  sta activities, x
  rts

.next0:
  ldx <currentActivity
  lda #0
  sta activities, x
  rts


;******************************************************************************
; wait padIn (activity #3-4)
;******************************************************************************
Adv_waitPadIn:
  lda <pad1trig
  and #$80
  beq .moveCursor
  ldx <currentActivity
  lda #0
  sta activities, x
  sta processCounters, x
  lda #$BF
  sta Adv_cursorSprite_I
  rts

.moveCursor:
  lda <Adv_cursorCol
  asl a
  asl a
  asl a
  clc
  adc #Adv_CURSORBASE_X
  sta Adv_cursorSprite_X
  lda <Adv_cursorRow
  asl a
  asl a
  asl a
  asl a
  clc
  adc #Adv_CURSORBASE_Y
  sta Adv_cursorSprite_Y

.cursorBlink:
  ldx <currentActivity
  lda processCounters, x

.process0:
  bne .process8
  lda #$0F
  sta Adv_cursorSprite_I
  inc processCounters, x
  rts

.process8:
  cmp #8
  bne .process15
  lda #$BF
  sta Adv_cursorSprite_I
  inc processCounters, x
  rts

.process15:
  cmp #15
  bne .nop
  lda #0
  sta processCounters, x
  rts

.nop:
  inc processCounters, x
  rts


;******************************************************************************
; command list (activity #4)
;******************************************************************************
Adv_commandList:
  lda Adv_skip
  and #$02
  bne .skip

  inc <currentActivity
  ldx <currentActivity
  lda activities, x

.act0: ; #0 R}hXg̓WJ
  bne .act1
  jmp Adv_loadCommandList

.act1: ; #1 R}hI҂
  cmp #1
  bne .act2
  jmp Adv_selectCommand

.act2: ; #2 J
  lda #0
  sta activities, x
  sta processCounters, x
  dex
  lda #2
  sta activities, x
  rts

.skip:
  ldx <currentActivity
  lda #2
  sta activities, x
  rts


;******************************************************************************
; load command list (activity #4-0)
;******************************************************************************
Adv_loadCommandList:
  ldx <currentActivity
  lda processCounters, x

.process0:
  bne .process1
  lda Adv_clistIndex
  asl a
  tay
  lda Adv_clistvector, y
  sta <Adv_clistData_LSB
  iny
  lda Adv_clistvector, y
  sta <Adv_clistData_MSB

  ldy #0
  lda [Adv_clistData_LSB], y
  sta <Adv_clistSize

  lda <Adv_clistData_LSB
  clc
  adc #1
  sta <Adv_clistData_LSB
  lda <Adv_clistData_MSB
  adc #0
  sta <Adv_clistData_MSB
.process0_next:
  inc processCounters, x
  rts

.process1:
  cmp #6
  bcs .process6
  lda #Adv_VRAMBASE2_LSB
  sta <address1_LSB
  lda #Adv_VRAMBASE2_MSB
  sta <address1_MSB
  
  lda processCounters, x
  sec
  sbc #1
  lsr a
  lsr a
  ora <address1_MSB
  sta <address1_MSB
  lda processCounters, x
  sec
  sbc #1
  asl a
  asl a
  asl a
  asl a
  asl a
  asl a
  clc
  adc <address1_LSB
  sta <address1_LSB
  bcc .process1_storeReg0
  inc <address1_MSB
.process1_storeReg0:
  lda REG_PPU_2
  lda <address1_MSB
  sta REG_PPU_6
  lda <address1_LSB
  sta REG_PPU_6
  ldy #0
.process1_loop0:
  lda #$00
  sta REG_PPU_7
  iny
  cpy #6
  bcc .process1_loop0
  lda <address1_LSB
  clc
  adc #32
  sta <address1_LSB
  bcc .process1_storeReg1
  inc <address1_MSB
.process1_storeReg1:
  lda REG_PPU_2
  lda <address1_MSB
  sta REG_PPU_6
  lda <address1_LSB
  sta REG_PPU_6
.process1_loop1:
  lda #$00
  sta REG_PPU_7
  iny
  cpy #12
  bcc .process1_loop1
  inc processCounters, x
  rts

.process6:
  lda #Adv_VRAMBASE2_LSB
  sta <address1_LSB
  lda #Adv_VRAMBASE2_MSB
  sta <address1_MSB
  
  lda processCounters, x
  sec
  sbc #6
  lsr a
  lsr a
  ora <address1_MSB
  sta <address1_MSB
  lda processCounters, x
  sec
  sbc #6
  asl a
  asl a
  asl a
  asl a
  asl a
  asl a
  clc
  adc <address1_LSB
  sta <address1_LSB
  lda <address1_MSB
  adc #0
  sta <address1_MSB
  ldy #0
  ldx #0
  lda #$04
  sta REG_PPU_0
.process6_loop0:
  lda REG_PPU_2
  lda <address1_MSB
  sta REG_PPU_6
  lda <address1_LSB
  sta REG_PPU_6
  lda [Adv_clistData_LSB], y
  pha
  lda <Adv_clistData_LSB
  clc
  adc #1
  sta <Adv_clistData_LSB
  lda <Adv_clistData_MSB
  adc #0
  sta <Adv_clistData_MSB
  pla
  cmp #$79
  beq .process6_drawChar2
  cmp #$7A
  beq .process6_drawChar2
.process6_drawChar1:
  pha
  lda #$00
  sta REG_PPU_7
  pla
  sta REG_PPU_7
  lda <address1_LSB
  clc
  adc #1
  sta <address1_LSB
  lda <address1_MSB
  adc #0
  sta <address1_MSB
  inx
  cpx #6
  bcc .process6_loop0
  bcs .process6_checkContinue
.process6_drawChar2:
  sta REG_PPU_7
  lda [Adv_clistData_LSB], y
  pha
  lda <Adv_clistData_LSB
  clc
  adc #1
  sta <Adv_clistData_LSB
  lda <Adv_clistData_MSB
  adc #0
  sta <Adv_clistData_MSB
  pla
  sta REG_PPU_7
  lda <address1_LSB
  clc
  adc #1
  sta <address1_LSB
  lda <address1_MSB
  adc #0
  sta <address1_MSB
  inx
  cpx #6
  bcc .process6_loop0
.process6_checkContinue:
  ldx <currentActivity
  lda processCounters, x
  sec
  sbc #5
  cmp <Adv_clistSize
  bcs .terminate
  inc processCounters, x
  rts

.terminate:
  lda #0
  sta processCounters, x
  inc activities, x
  rts


;******************************************************************************
; select command (activity #4-1)
;******************************************************************************
Adv_selectCommand:
  ldx <currentActivity
  lda processCounters, x
  cmp #$16
  bcc .scanPad
  jmp .process16

.scanPad:
  lda <pad1trig

.trigU:
  cmp #$08
  bne .trigD
  lda #16
  sta processCounters, x
  dec Adv_clistSelected
  lda Adv_clistSelected
  cmp #$FF
  bne .moveCursor
  ldy <Adv_clistSize
  dey
  tya
  sta Adv_clistSelected
  jmp .moveCursor

.trigD:
  cmp #$04
  bne .trigA
  lda #16
  sta processCounters, x
  inc Adv_clistSelected
  lda Adv_clistSelected
  cmp <Adv_clistSize
  bcc .moveCursor
  lda #0
  sta Adv_clistSelected
  jmp .moveCursor

.trigA:
  cmp #$80
  bne .trigB
  lda #0
  sta activities, x
  sta processCounters, x
  dex
  lda #2
  sta activities, x
  rts

.trigB:
  cmp #$40
  bne .trigSTART
  lda #$FF
  sta Adv_clistSelected
  lda #0
  sta activities, x
  sta processCounters, x
  dex
  lda #2
  sta activities, x
  rts

.trigSTART:
  cmp #$10
  bne .moveCursor
  lda #0
  sta activities, x
  sta processCounters, x
  dex
  lda #5
  sta activities, x
  rts

.moveCursor:
  lda #Adv_COMMANDBASE_X
  sta Adv_cursorSprite_X
  lda Adv_clistSelected
  asl a
  asl a
  asl a
  asl a
  clc
  adc #Adv_COMMANDBASE_Y
  sta Adv_cursorSprite_Y

.blinkCursor:
  ldx <currentActivity
  lda processCounters, x

.process0:
  bne .process8
  lda #$0F
  sta Adv_cursorSprite_I
  inc processCounters, x
  rts

.process8:
  cmp #8
  bne .process15
  lda #$BF
  sta Adv_cursorSprite_I
  inc processCounters, x
  rts

.process15:
  cmp #15
  bne .inclementProcess
  lda #0
  sta processCounters, x
  rts

.process16:
  cmp #16
  bne .process24
  lda #$0F
  sta Adv_cursorSprite_I
  inc processCounters, x
  rts

.process24:
  cmp #24
  bne .process31
  lda #$BF
  sta Adv_cursorSprite_I
  inc processCounters, x
  rts

.process31:
  cmp #31
  bne .inclementProcess
  lda #0
  sta processCounters, x
  rts

.inclementProcess:
  inc processCounters, x
  rts


;******************************************************************************
; data
;******************************************************************************
Adv_BG: ; $2000-$23BF
  ; $2000
  ;   +0   +1   +2   +3   +4   +5   +6   +7   +8   +9   +A   +B   +C   +D   +E   +F
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $01, $05, $05, $05, $05, $05, $05, $05, $05
  .db $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $02, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $07, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F
  .db $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $08, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $07, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F
  .db $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $08, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $07, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F
  .db $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $08, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $07, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F
  .db $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $08, $00, $00, $00, $00, $00

  ; $2100
  ;   +0   +1   +2   +3   +4   +5   +6   +7   +8   +9   +A   +B   +C   +D   +E   +F
  .db $00, $00, $00, $00, $00, $00, $00, $07, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F
  .db $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $08, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $07, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F
  .db $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $08, $00, $00, $00, $00, $00
  .db $00, $01, $05, $05, $05, $05, $02, $07, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F
  .db $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $08, $00, $00, $00, $00, $00
  .db $00, $07, $0F, $0F, $0F, $0F, $08, $07, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F
  .db $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $08, $00, $00, $00, $00, $00
  .db $00, $07, $0F, $0F, $0F, $0F, $08, $07, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F
  .db $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $08, $00, $00, $00, $00, $00
  .db $00, $07, $0F, $0F, $0F, $0F, $08, $07, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F
  .db $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $08, $00, $00, $00, $00, $00
  .db $00, $07, $0F, $0F, $0F, $0F, $08, $03, $06, $06, $06, $06, $06, $06, $06, $06
  .db $06, $06, $06, $06, $06, $06, $06, $06, $06, $06, $04, $00, $00, $00, $00, $00
  .db $00, $09, $0B, $0B, $0B, $0B, $0A, $05, $05, $05, $05, $05, $05, $05, $05, $05
  .db $05, $05, $05, $05, $02, $01, $05, $05, $05, $05, $05, $05, $05, $05, $02, $00

  ; $2200
  ;   +0   +1   +2   +3   +4   +5   +6   +7   +8   +9   +A   +B   +C   +D   +E   +F
  .db $00, $07, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $08, $07, $00, $00, $00, $00, $00, $00, $00, $00, $08, $00
  .db $00, $07, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $08, $07, $00, $00, $00, $00, $00, $00, $00, $00, $08, $00
  .db $00, $07, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $08, $07, $00, $00, $00, $00, $00, $00, $00, $00, $08, $00
  .db $00, $07, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $08, $07, $00, $00, $00, $00, $00, $00, $00, $00, $08, $00
  .db $00, $07, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $08, $07, $00, $00, $00, $00, $00, $00, $00, $00, $08, $00
  .db $00, $07, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $08, $07, $00, $00, $00, $00, $00, $00, $00, $00, $08, $00
  .db $00, $07, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $08, $07, $00, $00, $00, $00, $00, $00, $00, $00, $08, $00
  .db $00, $07, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $08, $07, $00, $00, $00, $00, $00, $00, $00, $00, $08, $00

  ; $2300
  ;   +0   +1   +2   +3   +4   +5   +6   +7   +8   +9   +A   +B   +C   +D   +E   +F
  .db $00, $07, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $08, $07, $00, $00, $00, $00, $00, $00, $00, $00, $08, $00
  .db $00, $07, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $08, $07, $00, $00, $00, $00, $00, $00, $00, $00, $08, $00
  .db $00, $03, $06, $06, $06, $06, $06, $06, $06, $06, $06, $06, $06, $06, $06, $06
  .db $06, $06, $06, $06, $04, $03, $06, $06, $06, $06, $06, $06, $06, $06, $04, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $45, $41, $5A, $52, $51, $72, $42, $7B, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00

Adv_BGA: ; $23C0-$23FF
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00

