; *** RAM reserve ***
EndCredit_seq_LSB       = $D0
EndCredit_seq_MSB       = $D1
EndCredit_seqData0      = $D2
EndCredit_seqData1      = $D3
EndCredit_cursorCol     = $D4
EndCredit_cursorRow     = $D5

; *** constants ***
EndCredit_VRAMBASE1_LSB = $03
EndCredit_VRAMBASE1_MSB = $22

;******************************************************************************
; main #0
;******************************************************************************
EndCredit_main0:
  inc <currentActivity
  ldx <currentActivity
  lda activities, x
  asl a
  tax
  lda EndCredit_mainvector, x
  sta <address1_LSB
  inx
  lda EndCredit_mainvector, x
  sta <address1_MSB
  jmp [address1_LSB]

EndCredit_mainvector:
  .dw EndCredit_init              ; #0 
  .dw EndCredit_fadein            ; #1 tF[hC
  .dw EndCredit_updateScreen      ; #2 ʍXV
  .dw EndCredit_fadeout           ; #3 tF[hAEg
  .dw EndCredit_terminate         ; #4 i^Cgʁj

EndCredit_terminate:
  lda #0
  ldx <currentActivity
  sta activities, x
  sta processCounters, x
  dex
  sta processCounters, x
  lda #1
  sta activities, x
  rts


;******************************************************************************
; main #1
;******************************************************************************
EndCredit_main1:

.waitScan:
  bit REG_PPU_2
  bvs .waitScan
.waitHit:
  bit REG_PPU_2
  bvc .waitHit

  lda #$80 ; enable NMI
           ; BG $0000
           ; SP $0000 8x8
  sta REG_PPU_0
  rts


;******************************************************************************
; init (activity #0)
;******************************************************************************
EndCredit_init:
  lda #0
  jsr MMC_changeCHR_Low

  ; load Pallet
  ldx #0
.loadPallet:
  lda EndCredit_pallet, x
  sta Adv_pallet, x
  inx
  cpx #32
  bne .loadPallet

  ; load BG $2000-$23BF
  lda #low(EndCredit_BG)
  sta <address1_LSB
  lda #high(EndCredit_BG)
  sta <address1_MSB
  lda #$00
  sta <address2_LSB
  lda #$20
  sta <address2_MSB
  lda #$C0
  sta <wordparam_LSB
  lda #$03
  sta <wordparam_MSB
  jsr loadVRAM

  ; load BG Attr $23C0-$23FF
  lda #low(EndCredit_BGA)
  sta <address1_LSB
  lda #high(EndCredit_BGA)
  sta <address1_MSB
  lda #$C0
  sta <address2_LSB
  lda #$23
  sta <address2_MSB
  lda #$40
  sta <wordparam_LSB
  lda #$00
  sta <wordparam_MSB
  jsr loadVRAM

  ; Sprite #0
  lda #122
  sta SPRITE_Y
  lda #248
  sta SPRITE_X
  lda #$BE
  sta SPRITE_I
  lda #$43
  sta SPRITE_A

  lda #0
  ldy #4
.clearSP:
  sta SPRITE_Y, y
  sta SPRITE_X, y
  sta SPRITE_I, y
  sta SPRITE_A, y
  iny
  iny
  iny
  iny
  bne .clearSP

  lda #$00
  sta <EndCredit_cursorCol
  sta <EndCredit_cursorRow

  lda #$FF
  sta Image1_index

  lda #low(EndCredit_seqData)
  sta EndCredit_seq_LSB
  lda #high(EndCredit_seqData)
  sta EndCredit_seq_MSB

  ldx <currentActivity
  inc activities, x
  rts


;******************************************************************************
; fade in (activity #1)
;******************************************************************************
EndCredit_fadein:
  lda #low(Adv_pallet)
  sta <address1_LSB
  lda #high(Adv_pallet)
  sta <address1_MSB
  jmp Util_fadein ; ėptF[hC


;******************************************************************************
; fade out (activity #3)
;******************************************************************************
EndCredit_fadeout:
  lda #low(Adv_pallet)
  sta <address1_LSB
  lda #high(Adv_pallet)
  sta <address1_MSB
  jmp Util_fadeout ; ėptF[hAEg


;******************************************************************************
; update screen (activity #2)
;******************************************************************************
EndCredit_updateScreen:
  inc <currentActivity
  ldx <currentActivity
  lda activities, x
  asl a
  tax
  lda EndCredit_usvector, x
  sta <address1_LSB
  inx
  lda EndCredit_usvector, x
  sta <address1_MSB
  jmp [address1_LSB]

EndCredit_usvector:
  .dw EndCredit_readSeq      ; #0 V[PXǍ
  .dw 0                      ; #1
  .dw EndCredit_clearText    ; #2 y[WieLXgNAj
  .dw EndCredit_drawChar     ; #3 Po
  .dw Image1_main            ; #4 摜1
  .dw 0                      ; #5 
  .dw EndCredit_wait         ; #6 EFCg


;******************************************************************************
; read sequence (activity #3-0)
;******************************************************************************
EndCredit_readSeq:

  ldy #0
  lda [EndCredit_seq_LSB], y
  sta <EndCredit_seqData0
  inc <EndCredit_seq_LSB
  bne .checkCommand
  inc <EndCredit_seq_MSB
.checkCommand:
  lda <EndCredit_seqData0
  cmp #$79 ; _
  beq EndCredit_cmdX2
  cmp #$7A ; _
  beq EndCredit_cmdX2
  and #$F0
  cmp #$F0
  bne EndCredit_cmdX1
  lda <EndCredit_seqData0
  and #$0F
  asl a
  tay
  lda EndCredit_cmdvector, y
  sta <address1_LSB
  iny
  lda EndCredit_cmdvector, y
  sta <address1_MSB
  ldy #0
  jmp [address1_LSB]

EndCredit_cmdvector:
  .dw EndCredit_cmdF0, EndCredit_cmdF1, EndCredit_cmdX1, EndCredit_cmdX1
  .dw EndCredit_cmdX1, EndCredit_cmdX1, EndCredit_cmdX1, EndCredit_cmdX1
  .dw EndCredit_cmdF8, EndCredit_cmdF9, EndCredit_cmdX1, EndCredit_cmdX1
  .dw EndCredit_cmdX1, EndCredit_cmdFD, EndCredit_cmdFE, EndCredit_cmdFF

EndCredit_cmdX1: ; Pói_Ȃj
  lda <EndCredit_seqData0
  sta <EndCredit_seqData1
  lda #$00
  sta <EndCredit_seqData0
.next:
  ldx <currentActivity
  lda #3
  sta activities, x
  rts

EndCredit_cmdX2: ; Pói_j
  lda [EndCredit_seq_LSB], y
  sta <EndCredit_seqData1
  inc <EndCredit_seq_LSB
  bne .next
  inc <EndCredit_seq_MSB
.next:
  ldx <currentActivity
  lda #3
  sta activities, x
  rts

EndCredit_cmdF0: ; s
  lda #0
  sta <Adv_cursorCol
  inc <Adv_cursorRow
  bne EndCredit_readSeq

EndCredit_cmdF1: ; 摜1
  lda [EndCredit_seq_LSB], y
  sta Image1_index
  inc <EndCredit_seq_LSB
  bne .next
  inc <EndCredit_seq_MSB
.next:
  ldx <currentActivity
  lda #4
  sta activities, x
  rts

EndCredit_cmdF8: ; BGM
  lda [EndCredit_seq_LSB], y
  sta Snd_bgm
  inc <EndCredit_seq_LSB
  bne .continue
  inc <EndCredit_seq_MSB
.continue:
  rts

EndCredit_cmdF9: ; SFX
  lda [EndCredit_seq_LSB], y
  sta Snd_sfx
  inc <EndCredit_seq_LSB
  bne .continue
  inc <EndCredit_seq_MSB
.continue:
  rts

EndCredit_cmdFD: ; ^C}EFCg
  ldx <currentActivity
  lda #6
  sta activities, x
  rts

EndCredit_cmdFE: ; y[W
  ldx <currentActivity
  lda #2
  sta activities, x
  rts

EndCredit_cmdFF: ; I[
  ldx <currentActivity
  lda #0
  sta activities, x
  sta processCounters, x
  dex
  inc activities, x
  sta processCounters, x
  rts


;******************************************************************************
; clear (activity #3-2)
;******************************************************************************
EndCredit_clearText:
  ldx <currentActivity
  lda processCounters, x
  cmp #26
  bcc .clear
  
.term:
  lda #0
  sta activities, x
  sta processCounters, x
  sta <EndCredit_cursorCol
  sta <EndCredit_cursorRow
  rts

.clear:
  lda #$04
  sta REG_PPU_0

  lda REG_PPU_2
  lda #EndCredit_VRAMBASE1_MSB
  sta REG_PPU_6
  lda processCounters, x
  clc
  adc #EndCredit_VRAMBASE1_LSB
  sta REG_PPU_6

  lda #$00
  sta REG_PPU_7
  sta REG_PPU_7
  sta REG_PPU_7
  sta REG_PPU_7
  sta REG_PPU_7
  sta REG_PPU_7
  sta REG_PPU_7
  sta REG_PPU_7
  sta REG_PPU_7
  sta REG_PPU_7

  inc processCounters, x
  rts


;******************************************************************************
; drawChar (activity #3-3)
;******************************************************************************
EndCredit_drawChar:
  lda #$04
  sta REG_PPU_0

  lda #EndCredit_VRAMBASE1_LSB
  sta <address1_LSB
  lda #EndCredit_VRAMBASE1_MSB
  sta <address1_MSB
  lda <Adv_cursorCol
  clc
  adc <address1_LSB
  sta <address1_LSB
  lda <Adv_cursorRow
  asl a
  asl a
  asl a
  asl a
  asl a
  asl a
  clc
  adc <address1_LSB
  sta <address1_LSB

  lda REG_PPU_2
  lda <address1_MSB
  sta REG_PPU_6
  lda <address1_LSB
  sta REG_PPU_6

  lda <EndCredit_seqData0
  sta REG_PPU_7
  lda <EndCredit_seqData1
  sta REG_PPU_7

  inc <Adv_cursorCol
  lda <Adv_cursorCol
  cmp #26
  bcc .next
  lda #0
  sta <Adv_cursorCol
  inc <Adv_cursorRow

.next:
  ldx <currentActivity
  lda #0
  sta activities, x
  rts


;******************************************************************************
; wait (activity #3-4)
;******************************************************************************
EndCredit_wait:
  ldx <currentActivity
  lda processCounters, x
  cmp #60
  bcc .countup
  lda #0
  sta processCounters, x
  sta activities, x
  rts
.countup:
  inc processCounters, x
  rts


;******************************************************************************
; data
;******************************************************************************
EndCredit_pallet:
  .db $0F, $0F, $0F, $30, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F
  .db $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F

EndCredit_BG: ; $2000-$23BF
  ; $2000
  ;   +0   +1   +2   +3   +4   +5   +6   +7   +8   +9   +A   +B   +C   +D   +E   +F
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00

  ; $2100
  ;   +0   +1   +2   +3   +4   +5   +6   +7   +8   +9   +A   +B   +C   +D   +E   +F
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00

  ; $2200
  ;   +0   +1   +2   +3   +4   +5   +6   +7   +8   +9   +A   +B   +C   +D   +E   +F
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00

  ; $2300
  ;   +0   +1   +2   +3   +4   +5   +6   +7   +8   +9   +A   +B   +C   +D   +E   +F
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00

EndCredit_BGA: ; $23C0-$23FF
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00

EndCredit_seqData:
  .db $F1, $0D
  .db $1D, $0D, $0F, $18, $0B, $1C, $13, $19, $F0
  .db $00, $00, $00, $00, $2A, $2B, $2C, $2D, $2E, $FD, $FD, $FD
  .db $FE, $F1, $06
  .db $1D, $19, $1F, $18, $0E, $F0
  .db $00, $00, $00, $00, $2A, $2B, $2C, $2D, $2E, $FD, $FD, $FD
  .db $FE, $F1, $03
  .db $1A, $1C, $19, $11, $1C, $0B, $17, $F0
  .db $00, $00, $00, $00, $2A, $2B, $2C, $2D, $2E, $FD, $FD, $FD
  .db $FE, $F1, $0D
  .db $00, $00, $00, $00, $00, $29, $2A, $2B, $2C, $2D, $2E, $26, $79, $53, $6F, $79
  .db $45, $47, $79, $54, $42, $00, $03, $01, $02, $02
  .db $FD, $FD, $FD, $FD, $FD
  .db $FD, $FD, $FD, $FD, $FD
  .db $FD, $FD, $FD, $FD, $FD
  .db $FD, $FD, $FD, $FD, $FD
  .db $FD, $FD, $FD, $FD, $FD
  .db $FD, $FD, $FD, $FD, $FD
  .db $FF
