; *** RAM reserve ***
Title_cursorCol    = $D4 ; Adv_cursorColƋ
Title_addr1_LSB    = $E0
Title_addr1_MSB    = $E1
Title_addr2_LSB    = $E2
Title_addr2_MSB    = $E3

Title_cursor0Y     = $0204
Title_cursor0I     = $0205
Title_cursor0A     = $0206
Title_cursor0X     = $0207
Title_cursor1Y     = $0208
Title_cursor1I     = $0209
Title_cursor1A     = $020A
Title_cursor1X     = $020B

Title_selected     = $0312 ; Adv_clistSelectedƋ

;******************************************************************************
; main #0
;******************************************************************************
Title_main0:
  inc <currentActivity
  ldx <currentActivity
  lda activities, x
  asl a
  tax
  lda Title_main_VECTOR, x
  sta <address1_LSB
  inx
  lda Title_main_VECTOR, x
  sta <address1_MSB
  jmp [address1_LSB]

Title_main_VECTOR:
  .dw Title_init                  ; #0 
  .dw Title_fadein                ; #1 tF[hC
  .dw Title_waitPadIn             ; #2 pbh͑҂i͂߂/Âj
  .dw Title_inputPassword         ; #3 pX[h̓
  .dw Password_load               ; #4 pX[h烍[h
  .dw Title_checkError            ; #5 G[`FbN
  .dw Title_fadeout               ; #6 tF[hAEg
  .dw Title_terminate             ; #7 terminate(next activity)


;******************************************************************************
; main #1
;******************************************************************************
Title_main1:

.waitScan:
  bit REG_PPU_2
  bvs .waitScan
.waitHit:
  bit REG_PPU_2
  bvc .waitHit

  lda #$80 ; enable NMI
           ; BG $0000
           ; SP $0000 8x8
  sta REG_PPU_0
  rts


;******************************************************************************
; initialize (activity #0)
;******************************************************************************
Title_init:
  lda #2
  sta Snd_bgm
  lda #0
  sta Snd_sfx
  
  lda #1
  jsr MMC_changeCHR_Low
  
  lda #2
  jsr MMC_changeCHR_High

  ; load BG $2000-$23BF
  lda #low(Title_BG)
  sta <address1_LSB
  lda #high(Title_BG)
  sta <address1_MSB
  lda #$00
  sta <address2_LSB
  lda #$20
  sta <address2_MSB
  lda #$C0
  sta <wordparam_LSB
  lda #$03
  sta <wordparam_MSB
  jsr loadVRAM

  ; load BG Attr $23C0-$23FF
  lda #low(Title_BGA)
  sta <address1_LSB
  lda #high(Title_BGA)
  sta <address1_MSB
  lda #$C0
  sta <address2_LSB
  lda #$23
  sta <address2_MSB
  lda #$40
  sta <wordparam_LSB
  lda #$00
  sta <wordparam_MSB
  jsr loadVRAM

  ; Sprite #0
  lda #86
  sta SPRITE_Y
  lda #248
  sta SPRITE_X
  lda #$BE
  sta SPRITE_I
  lda #$43
  sta SPRITE_A

  ; Sprite #1 J[\#0i͂߂/Âj
  lda #96
  sta Title_cursor0X
  lda #0
  sta Title_cursor0Y
  lda #$0F
  sta Title_cursor0I
  lda #$03
  sta Title_cursor0A

  ; Sprite #2 J[\#1ipX[h̓J[\j
  lda #168
  sta Title_cursor1Y
  lda #0
  sta Title_cursor1X
  lda #$0F
  sta Title_cursor1I
  lda #$03
  sta Title_cursor1A

  lda #$00
  sta Title_selected

  lda #$10
  sta Password_input
  sta Password_input+1
  sta Password_input+2
  sta Password_input+3
  sta Password_input+4
  sta Password_input+5
  sta Password_input+6
  sta Password_input+7
  sta Password_input+8
  sta Password_input+9
  sta Password_input+10
  sta Password_input+11
  sta Password_input+12
  sta Password_input+13
  sta Password_input+14

  ldx <currentActivity
  inc activities, x
  rts


;******************************************************************************
; fade in (activity #1)
;******************************************************************************
Title_fadein:
  lda #low(Title_pallet)
  sta <address1_LSB
  lda #high(Title_pallet)
  sta <address1_MSB
  jmp Util_fadein


;******************************************************************************
; wait pad in (activity #2)
;******************************************************************************
Title_waitPadIn:
  ldx <currentActivity
  lda processCounters, x
  beq .curOn
  cmp #8
  beq .curOff
  cmp #15
  beq .zeroCounter
  bne .incCounter
.curOn:
  lda #$BF
  sta Title_cursor0I
  bne .incCounter
.curOff:
  lda #$0F
  sta Title_cursor0I
  bne .incCounter
.zeroCounter:
  lda #0
  sta processCounters, x
  beq .moveCur
.incCounter:
  inc processCounters, x
.moveCur:
  lda Title_selected
  asl a
  asl a
  asl a
  asl a
  clc
  adc #135
  sta Title_cursor0Y
.trigA_START:
  lda <pad1trig
  and #$90
  beq .trigUp
  lda #1
  sta Snd_sfx
  jmp .checkSelected
.trigUp:
  lda <pad1trig
  cmp #$08
  bne .trigDown
  lda #0
  sta Title_selected
  rts
.trigDown:
  cmp #$04
  bne .nop
  lda #1
  sta Title_selected
  rts
.nop:
  rts
.checkSelected:
  lda Title_selected
  bne .continue
.newgame:
  ldx <currentActivity
  lda #6
  sta activities, x
  lda #0
  sta processCounters, x
  sta Title_cursor0Y
  sta Title_cursor0X
  sta Title_cursor1Y
  sta Title_cursor1X
  rts
.continue:
  lda #$BF
  sta Title_cursor0I
  ldx <currentActivity
  inc activities, x
  lda #0
  sta processCounters, x
  sta <Title_cursorCol
  rts


;******************************************************************************
; input password (activity #3)
;******************************************************************************
Title_inputPassword:
  ldx <currentActivity
  lda processCounters, x
  beq .curOn
  cmp #8
  beq .curOff
  cmp #15
  beq .zeroCounter
  bne .incCounter
.curOn:
  lda #$BD
  sta Title_cursor1I
  bne .incCounter
.curOff:
  lda #$0F
  sta Title_cursor1I
  bne .incCounter
.zeroCounter:
  lda #0
  sta processCounters, x
  beq .moveCur
.incCounter:
  inc processCounters, x
.moveCur:
  lda Title_cursorCol
  asl a
  asl a
  asl a
  clc
  adc #96
  sta Title_cursor1X
.trigA:
  lda <pad1trig
  cmp #$80
  bne .trigB
  lda Title_cursorCol
  cmp #14
  bne .nextCol
.nextAct:
  lda #0
  sta processCounters, x
  inc activities, x
  rts
.nextCol:
  inc Title_cursorCol
  bne .drawChar
.trigB:
  cmp #$40
  bne .trigUp
  lda Title_cursorCol
  beq .firstCol
  dec Title_cursorCol
  rts
.firstCol:
  lda #0
  sta Title_cursor1X
  ldx <currentActivity
  dec activities, x
  lda #$0F
  sta Title_cursor1I
  rts
.trigUp:
  cmp #$08
  bne .trigDown
  ldx Title_cursorCol
  inc Password_input, x
  lda Password_input, x
  cmp #$20
  bcc .drawChar
  lda #$10
  sta Password_input, x
  bne .drawChar
.trigDown:
  cmp #$04
  bne .drawChar
  ldx Title_cursorCol
  dec Password_input, x
  lda Password_input, x
  cmp #$10
  bcs .drawChar
  lda #$1F
  sta Password_input, x
.drawChar:
  lda REG_PPU_2
  lda #$22
  sta REG_PPU_6
  lda #$AC
  clc
  adc Title_cursorCol
  sta REG_PPU_6
  ldx Title_cursorCol
  lda Password_input, x
  sta REG_PPU_7
  rts


;******************************************************************************
; check Error (activity #5)
;******************************************************************************
Title_checkError:
  lda Password_result
  beq .ok
.ng:
  lda #2
  sta Snd_sfx
  lda #0
  sta Title_cursorCol ; J[\ړ
  lda #3
  ldx <currentActivity
  sta activities, x
  rts
.ok:
  lda #1
  sta Snd_sfx
  lda #6
  ldx <currentActivity
  inc activities, x
  lda #0
  sta Title_cursor1X
  lda #$0F
  sta Title_cursor1I
  lda <Events_currentLoc
  beq .noskip ; L#0̓XLbvȂ
  lda #$80
  sta Adv_skip
.noskip:
  rts



;******************************************************************************
; fade out (activity #6)
;******************************************************************************
Title_fadeout:
  lda #low(Title_pallet)
  sta <address1_LSB
  lda #high(Title_pallet)
  sta <address1_MSB
  jmp Util_fadeout


;******************************************************************************
; terminate (activity #7)
;******************************************************************************
Title_terminate:
  ldx <currentActivity
  lda #0
  sta activities, x
  sta processCounters, x
  dex
  inc activities, x
  sta processCounters, x
  rts


;******************************************************************************
; data
;******************************************************************************
Title_pallet:
  .db $0F, $30, $22, $32, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F
  .db $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $0F, $11

Title_BG: ; $2000-$23BF
  ; $2000
  ;   +0   +1   +2   +3   +4   +5   +6   +7   +8   +9   +A   +B   +C   +D   +E   +F
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $40, $41, $42, $43, $44, $45, $46, $46, $46, $46, $46
  .db $47, $48, $49, $4A, $4B, $4C, $4D, $4E, $4F, $50, $51, $52, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $53, $54, $55, $56, $57, $58, $46, $59, $5A, $5B, $46
  .db $5C, $5D, $5E, $5F, $60, $61, $62, $63, $64, $65, $66, $67, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $53, $68, $69, $6A, $6B, $46, $6C, $6D, $6E, $6F, $70
  .db $71, $72, $73, $74, $75, $76, $77, $78, $79, $7A, $7B, $7C, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $7D, $7E, $7F, $80, $81, $82, $83, $84, $85, $86, $87
  .db $88, $89, $8A, $8B, $8C, $8D, $8E, $8F, $90, $91, $92, $93, $00, $00, $00, $00

  ; $2100
  ;   +0   +1   +2   +3   +4   +5   +6   +7   +8   +9   +A   +B   +C   +D   +E   +F
  .db $00, $00, $00, $00, $00, $94, $95, $96, $97, $98, $99, $9A, $9B, $9C, $9D, $9E
  .db $9F, $A0, $A1, $8B, $A2, $A3, $A4, $A5, $A6, $A7, $A8, $A9, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $AA, $AB, $AC, $AD, $AE, $AF, $46, $46, $B0, $B1, $46
  .db $B2, $B3, $B4, $B5, $B6, $B7, $B8, $B9, $BA, $BB, $BC, $BD, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $79, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $44, $56, $00, $59
  .db $00, $5A, $50, $49, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $79, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $50, $41, $48
  .db $6F, $5A, $6F, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $01, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05
  .db $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $05, $02, $00

  ; $2200
  ;   +0   +1   +2   +3   +4   +5   +6   +7   +8   +9   +A   +B   +C   +D   +E   +F
  .db $00, $07, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $79, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $08, $00
  .db $00, $07, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $5A, $4B, $63
  .db $45, $68, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $08, $00
  .db $00, $07, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $79, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $08, $00
  .db $00, $07, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $52, $52, $46
  .db $45, $68, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $08, $00
  .db $00, $07, $00, $00, $00, $7A, $00, $00, $00, $79, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $08, $00
  .db $00, $07, $00, $00, $00, $9A, $8C, $AD, $4F, $94, $34, $00, $10, $10, $10, $10
  .db $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $10, $00, $00, $00, $08, $00
  .db $00, $07, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $08, $00
  .db $00, $03, $06, $06, $06, $06, $06, $06, $06, $06, $06, $06, $06, $06, $06, $06
  .db $06, $06, $06, $06, $06, $06, $06, $06, $06, $06, $06, $06, $06, $06, $04, $00

  ; $2300
  ;   +0   +1   +2   +3   +4   +5   +6   +7   +8   +9   +A   +B   +C   +D   +E   +F
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $79, $00, $79, $00, $79, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $38, $0D, $0E, $5B, $6C, $62, $35, $53, $6F, $45, $47, $54, $42
  .db $00, $12, $10, $11, $11, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $45, $41, $5A, $52, $51, $72, $42, $7B, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00

Title_BGA: ; $23C0-$23FF
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00
  .db $00, $00, $00, $00, $00, $00, $00, $00

