; S̗-̌/SYSTEM1.1
; Copyright (C) 2011 saguruma
;
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.

; *** iNes-Header ***
  .inesprg  8    ; PRG-ROM 128KByte(1Mbit)
  .ineschr 16    ; CHR-ROM 128KByte(1Mbit)
  .inesmir  1    ; V-MIRROR - No SaveRAM
  .inesmap  1    ; MMC1


; ===== PRG-ROM [Start] =====
  .bank 0 ; PRG bank #0
  .org $8000
  .include "mod\mod_events.asm"
  .include "mod\mod_debug.asm"
  .include "mod\mod_clist05.asm"
  .include "mod\mod_clist06.asm"
  .include "mod\mod_clist07.asm"
  .include "mod\mod_clist09.asm"
  .include "mod\mod_clist11.asm"
  .include "mod\mod_clist12.asm"
  .include "mod\mod_clist13.asm"
  .include "mod\mod_clist14.asm"
  .include "mod\mod_clist20.asm"
  .include "mod\mod_clist21.asm"
  .include "mod\mod_clist30.asm"
  .include "mod\mod_clist31.asm"

  .bank 1
  .org $A000
  .include "dat\image1.dat"
  .include "dat\image2.dat"
Adv_pallet0:
  .incbin "pal\pal00.dat"


  .bank 2 ; PRG bank #1
  .org $8000
  .include "dat\bgm.dat"
  .include "dat\sfx.dat"
  .include "dat\seq0.dat"

  .bank 3
  .org $A000
  .include "dat\seq1.dat"

  .bank 4 ; PRG bank #2
  .org $8000
  .include "dat\seq2.dat"
  ; blank

  .bank 5
  .org $A000
  ; blank

  .bank 6 ; PRG bank #3
  .org $8000
  ; blank

  .bank 7
  .org $A000
  ; blank

  .bank 8 ; PRG bank #4
  .org $8000
  ; blank

  .bank 9
  .org $A000
  ; blank

  .bank 10 ; PRG bank #5
  .org $8000
  ; blank

  .bank 11
  .org $A000
  ; blank

  .bank 12 ; PRG bank #6
  .org $8000
  ; blank

  .bank 13
  .org $A000
  ; blank

  .bank 14 ; PRG bank #7
  .org $C000
  ; DMCf[^p
  
  .org $C800
  .include "mod\mod_sound.asm"
  .include "mod\mod_endcredit.asm"

  .include "dat\clist.dat"



  .bank 15
  .org $E000
;******************************************************************************
; INIT
;******************************************************************************
INIT:
  jsr MMC_resetModeMirroring
  jsr Snd_init

  ; pbg]
  lda #0
  jsr MMC_changePRG
  lda #low(Adv_pallet0)
  sta <address1_LSB
  lda #high(Adv_pallet0)
  sta <address1_MSB
  lda #low(Adv_pallet)
  sta <address2_LSB
  lda #high(Adv_pallet)
  sta <address2_MSB
  ldy #0
.loop:
  lda [address1_LSB], y
  sta [address2_LSB], y
  iny
  cpy #$20
  bcc .loop

  lda #$90 ; enable NMI
           ; BG $1000
           ; SP $0000 8x8
  sta <ppu0

  lda #$1E ; enable BG&SP
           ; disable mask
  sta <ppu1
  rts


;******************************************************************************
; MAIN #0
;******************************************************************************
MAIN0:
  lda #0
  sta <currentActivity
  lda activities
  asl a
  tax
  lda MAIN0_VECTOR, x
  sta <address1_LSB
  inx
  lda MAIN0_VECTOR, x
  sta <address1_MSB
  jmp [address1_LSB]

MAIN0_VECTOR:
  .dw License_main      ; CZX
  .dw Title_main0       ; ^Cg
  .dw Adv_main0         ; C
  .dw EndCredit_main0   ; GhNWbg


;******************************************************************************
; MAIN #1
;******************************************************************************
MAIN1:
  lda #1
  jsr MMC_changePRG
  jsr Snd_main

  lda activities
  asl a
  tax
  lda MAIN1_VECTOR, x
  sta <address1_LSB
  inx
  lda MAIN1_VECTOR, x
  sta <address1_MSB
  jmp [address1_LSB]

MAIN1_VECTOR:
  .dw MAIN1_NOP         ; CZXʁiȂj
  .dw Title_main1       ; ^Cg
  .dw Adv_main1         ; C
  .dw EndCredit_main1   ; GhNWbg

MAIN1_NOP:
  rts

  .include "dat\seqvector.dat"
  .include "dat\image1v.dat"
  .include "dat\image2v.dat"
  .include "dat\bgmvector.dat"
  .include "dat\sfxvector.dat"

  .include "mod\mod_password.asm"
  .include "mod\mod_image2.asm"
  .include "mod\mod_image1.asm"
  .include "mod\mod_advmain.asm"
  .include "mod\mod_title.asm"
  .include "mod\mod_license.asm"
  .include "mod\mod_util.asm"
  .include "mod\mod_rng.asm"
  .include "mod\mod_system.asm"
; ===== PRG-ROM [End] =====

; ===== CHR-ROM [Start] =====
  .bank 16
  .incbin "chr\chr00.chr"

  .bank 17
  .incbin "chr\chr01.chr"

  .bank 18
  .incbin "chr\chr02.chr"

  .bank 19
  .incbin "chr\chr03.chr"

  .bank 20
  .incbin "chr\chr04.chr"

  .bank 21
  .incbin "chr\chr05.chr"

  .bank 22
  .incbin "chr\chr06.chr"

  .bank 23
  .incbin "chr\chr07.chr"

  .bank 24
  .incbin "chr\chr08.chr"

  .bank 25
  .incbin "chr\chr09.chr"

  .bank 26
  .incbin "chr\chr10.chr"

  .bank 27
  .incbin "chr\chr11.chr"

  .bank 28
  .incbin "chr\chr12.chr"

  .bank 29
  .incbin "chr\chr13.chr"

  .bank 30
  .incbin "chr\chr14.chr"

  .bank 31
  .incbin "chr\chr15.chr"

; ===== CHR-ROM [End] =====

